package main

import (
	slurmTianhe "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	slurmserver "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/server"
	"code.gitlink.org.cn/JCCE/PCM.git/common/config"
	"code.gitlink.org.cn/JCCE/PCM.git/common/server"
	"go.uber.org/zap"
	"google.golang.org/grpc"
)

func main() {

	// 初始化配置以及数据库
	config.InitConfig()

	// 新建一个zap logger实例
	logger, _ := zap.NewDevelopment()

	// logger.Sugar().Fatal 直接可以少几行判错的代码
	logger.Sugar().Fatal(server.RunGRPCServer(&server.GRPCConfig{
		Name: "pcm_slurm",
		Addr: "0.0.0.0:8881",
		RegisterFunc: func(g *grpc.Server) {
			slurmTianhe.RegisterSlurmServiceServer(g, &slurmserver.Server{})
		},
		Logger: logger,
	}))
}
