package server

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	slurmer "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/common"
	"context"
)

func ListUsers(ctx context.Context, req *pbslurm.ListUsersReq) (*pbslurm.ListUsersResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListUsers(ctx, req)
	return resp, nil
}

func GetUser(ctx context.Context, req *pbslurm.GetUserReq) (*pbslurm.GetUserResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetUser(ctx, req)
	return resp, nil
}

func AddUser(ctx context.Context, req *pbslurm.AddUserReq) (*pbslurm.AddUserResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.AddUser(ctx, req)
	return resp, nil
}

func DeleteUser(ctx context.Context, req *pbslurm.DeleteUserReq) (*pbslurm.DeleteUserResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.DeleteUser(ctx, req)
	return resp, nil
}

func ListAssociations(ctx context.Context, req *pbslurm.ListAssociationsReq) (*pbslurm.ListAssociationsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListAssociations(ctx, req)
	return resp, nil
}

func GetAssociation(ctx context.Context, req *pbslurm.GetAssociationReq) (*pbslurm.GetAssociationResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetAssociation(ctx, req)
	return resp, nil
}

func ListAccounts(ctx context.Context, req *pbslurm.ListAccountsReq) (*pbslurm.ListAccountsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListAccounts(ctx, req)
	return resp, nil
}

func GetAccount(ctx context.Context, req *pbslurm.GetAccountReq) (*pbslurm.GetAccountResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetAccount(ctx, req)
	return resp, nil
}

func AddAccount(ctx context.Context, req *pbslurm.AddAccountReq) (*pbslurm.AddAccountResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.AddAccount(ctx, req)
	return resp, nil
}

func DeleteAccount(ctx context.Context, req *pbslurm.DeleteAccountReq) (*pbslurm.DeleteAccountResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.DeleteAccount(ctx, req)
	return resp, nil
}

func ListQoses(ctx context.Context, req *pbslurm.ListQosesReq) (*pbslurm.ListQosesResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListQoses(ctx, req)
	return resp, nil
}

func ListWckeys(ctx context.Context, req *pbslurm.ListWckeysReq) (*pbslurm.ListWckeysResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListWckeys(ctx, req)
	return resp, nil
}

func GetWckey(ctx context.Context, req *pbslurm.GetWckeyReq) (*pbslurm.GetWckeyResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetWckey(ctx, req)
	return resp, nil
}

func ListClusters(ctx context.Context, req *pbslurm.ListClustersReq) (*pbslurm.ListClustersResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListClusters(ctx, req)
	return resp, nil
}

func GetCluster(ctx context.Context, req *pbslurm.GetClusterReq) (*pbslurm.GetClusterResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetCluster(ctx, req)
	return resp, nil
}

func DeleteCluster(ctx context.Context, req *pbslurm.DeleteClusterReq) (*pbslurm.DeleteClusterResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.DeleteCluster(ctx, req)
	return resp, nil
}

func AddCluster(ctx context.Context, req *pbslurm.AddClusterReq) (*pbslurm.AddClusterResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.AddCluster(ctx, req)
	return resp, nil
}

func ListNodes(ctx context.Context, req *pbslurm.ListNodesReq) (*pbslurm.ListNodesResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListNodes(ctx, req)
	return resp, nil
}

func GetNode(ctx context.Context, req *pbslurm.GetNodeReq) (*pbslurm.GetNodeResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetNode(ctx, req)
	return resp, nil
}

func ListPartitions(ctx context.Context, req *pbslurm.ListPartitionsReq) (*pbslurm.ListPartitionsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListPartitions(ctx, req)
	return resp, nil
}

func GetPartition(ctx context.Context, req *pbslurm.GetPartitionReq) (*pbslurm.GetPartitionResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetPartition(ctx, req)
	return resp, nil
}

func GetReservation(ctx context.Context, req *pbslurm.GetReservationReq) (*pbslurm.GetReservationResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetReservation(ctx, req)
	return resp, nil
}

func ListReservations(ctx context.Context, req *pbslurm.ListReservationsReq) (*pbslurm.ListReservationsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListReservations(ctx, req)
	return resp, nil
}

func ListJobs(ctx context.Context, req *pbslurm.ListJobsReq) (*pbslurm.ListJobsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListJobs(ctx, req)
	return resp, nil
}

func GetJob(ctx context.Context, req *pbslurm.GetJobReq) (*pbslurm.GetJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetJob(ctx, req)
	return resp, nil
}

func SubmitJob(ctx context.Context, req *pbslurm.SubmitJobReq) (*pbslurm.SubmitJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.SubmitJob(ctx, req)
	return resp, nil
}

func DeleteJob(ctx context.Context, req *pbslurm.DeleteJobReq) (*pbslurm.DeleteJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.DeleteJob(ctx, req)
	return resp, nil
}

func UpdateJob(ctx context.Context, req *pbslurm.UpdateJobReq) (*pbslurm.UpdateJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.UpdateJob(ctx, req)
	return resp, nil
}

func GetDiag(ctx context.Context, req *pbslurm.DiagReq) (*pbslurm.DiagResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetDiag(ctx, req)
	return resp, nil
}

func ListDbJobs(ctx context.Context, req *pbslurm.ListDbJobsReq) (*pbslurm.ListDbJobsResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.ListDbJobs(ctx, req)
	return resp, nil
}

func GetDbJob(ctx context.Context, req *pbslurm.GetDbJobReq) (*pbslurm.GetDbJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetDbJob(ctx, req)
	return resp, nil
}

func DeleteQos(ctx context.Context, req *pbslurm.DeleteQosReq) (*pbslurm.DeleteQosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.DeleteQos(ctx, req)
	return resp, nil
}

func AddQos(ctx context.Context, req *pbslurm.AddQosReq) (*pbslurm.AddQosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.AddQos(ctx, req)
	return resp, nil
}

func GetQos(ctx context.Context, req *pbslurm.GetQosReq) (*pbslurm.GetQosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	if slurm == nil {
		return nil, nil
	}
	resp, _ := slurm.GetQos(ctx, req)
	return resp, nil
}
