package slurmer

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"code.gitlink.org.cn/JCCE/PCM.git/common/ssh"
	"context"
	"strings"
)

func (slurmStruct SlurmStruct) ListAccounts(ctx context.Context, req *pbslurm.ListAccountsReq) (*pbslurm.ListAccountsResp, error) {

	acctList := tianhe.GetAcctInfo()

	resp := pbslurm.ListAccountsResp{}
	for _, acct := range acctList.AcctInfoList {
		//AcctInfoResult := pbslurm.AccountInfo{}
		//AcctInfoResult.Name = Acct.Name
		acctInfoResult := acct

		resp.AccountInfos = append(resp.AccountInfos, &acctInfoResult)
	}

	return &resp, nil
}

func (slurmStruct SlurmStruct) GetAccount(ctx context.Context, req *pbslurm.GetAccountReq) (*pbslurm.GetAccountResp, error) {

	acctList := tianhe.GetAcctInfo()

	resp := pbslurm.GetAccountResp{}
	for _, acct := range acctList.AcctInfoList {
		acctInfoResult := acct
		if strings.Contains(acct.Name, req.AccountName) {
			resp.AccountInfos = append(resp.AccountInfos, &acctInfoResult)
		}
	}

	return &resp, nil
}

func (slurmStruct SlurmStruct) AddAccount(ctx context.Context, req *pbslurm.AddAccountReq) (*pbslurm.AddAccountResp, error) {

	cmd := "/usr/local/bin/sacctmgr add account "

	cmd = cmd + req.Names
	if len(req.Clusters) != 0 {
		cmd = cmd + " Clusters=" + req.Clusters
	}
	if len(req.DefaultQos) != 0 {
		cmd = cmd + " DefaultQOS=" + req.DefaultQos
	}
	if len(req.Description) != 0 {
		cmd = cmd + " Description=\"" + req.Description + "\""
	}
	if len(req.FairShare) != 0 {
		cmd = cmd + " Fairshare=" + req.FairShare
	}
	if len(req.GrpCpuMins) != 0 {
		cmd = cmd + " GrpCPUMins=" + req.GrpCpuMins
	}
	if len(req.GrpCpus) != 0 {
		cmd = cmd + " GrpCPUs=" + req.GrpCpus
	}
	if len(req.GrpJobs) != 0 {
		cmd = cmd + " GrpJobs=" + req.GrpJobs
	}
	if len(req.GrpMemory) != 0 {
		cmd = cmd + " GrpMemory=" + req.GrpMemory
	}
	if len(req.GrpNodes) != 0 {
		cmd = cmd + " GrpNodes=" + req.GrpNodes
	}
	if len(req.GrpSubmitJobs) != 0 {
		cmd = cmd + " GrpSubmitJob=" + req.GrpSubmitJobs
	}
	if len(req.GrpWall) != 0 {
		cmd = cmd + " GrpWall=" + req.GrpWall
	}
	if len(req.MaxCpuMins) != 0 {
		cmd = cmd + " MaxCPUMins=" + req.MaxCpuMins
	}
	if len(req.MaxCpus) != 0 {
		cmd = cmd + " MaxCPUs=" + req.MaxCpus
	}
	if len(req.MaxJobs) != 0 {
		cmd = cmd + " MaxJobs=" + req.MaxJobs
	}
	if len(req.MaxNodes) != 0 {
		cmd = cmd + " MaxNodes=" + req.MaxNodes
	}
	if len(req.MaxSubmitJobs) != 0 {
		cmd = cmd + " MaxSubmitJobs=" + req.MaxSubmitJobs
	}
	if len(req.MaxWall) != 0 {
		cmd = cmd + " MaxWall=" + req.MaxWall
	}
	if len(req.Organization) != 0 {
		cmd = cmd + " Organization=" + req.Organization
	}
	if len(req.Parent) != 0 {
		cmd = cmd + " Parent=" + req.Parent
	}
	if len(req.QosLevel) != 0 {
		cmd = cmd + " QosLevel=" + req.QosLevel
	}

	cmd = cmd + " -i"

	result := ssh.ExecCommand(cmd)

	resp := pbslurm.AddAccountResp{}
	resp.Result = result

	return &resp, nil
}

func (slurmStruct SlurmStruct) DeleteAccount(ctx context.Context, req *pbslurm.DeleteAccountReq) (*pbslurm.DeleteAccountResp, error) {

	cmd := "/usr/local/bin/sacctmgr delete account "
	cmd = cmd + req.Names
	cmd = cmd + " -i"

	result := ssh.ExecCommand(cmd)

	resp := pbslurm.DeleteAccountResp{}
	resp.Result = result

	return &resp, nil
}
