package slurmer

import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"context"
	"strings"
)

func (slurmStruct SlurmStruct) ListAssociations(ctx context.Context, req *pbslurm.ListAssociationsReq) (*pbslurm.ListAssociationsResp, error) {

	assocList := tianhe.GetAssociationInfos()

	resp := pbslurm.ListAssociationsResp{}
	for _, assoc := range assocList.AssocInfoList {
		assocResult := assoc
		resp.AssocInfos = append(resp.AssocInfos, &assocResult)
	}

	return &resp, nil
}

func (slurmStruct SlurmStruct) GetAssociation(ctx context.Context, req *pbslurm.GetAssociationReq) (*pbslurm.GetAssociationResp, error) {

	assocList := tianhe.GetAssociationInfos()

	resp := pbslurm.GetAssociationResp{}

	for _, assoc := range assocList.AssocInfoList {
		if (len(req.Cluster) != 0 || len(req.User) != 0 || len(req.Account) != 0 || len(req.Partition) != 0) && strings.Contains(assoc.Cluster, req.Cluster) && strings.Contains(assoc.Acct, req.Account) && strings.Contains(assoc.User, req.User) && strings.Contains(assoc.Partition, req.Partition) {
			assocResult := assoc
			resp.AssocInfos = append(resp.AssocInfos, &assocResult)
		}
	}

	return &resp, nil
}
