package slurmer

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"code.gitlink.org.cn/JCCE/PCM.git/common/ssh"
	"context"
	"strings"
)

func (slurmStruct SlurmStruct) ListClusters(ctx context.Context, req *pbslurm.ListClustersReq) (*pbslurm.ListClustersResp, error) {

	clusterList := tianhe.GetClusterInfo()

	resp := pbslurm.ListClustersResp{}
	for _, cluster := range clusterList.ClusterInfoList {
		clusterInfoResult := pbslurm.ClusterInfo{}
		clusterInfoResult = cluster
		resp.ClusterInfos = append(resp.ClusterInfos, &clusterInfoResult)
	}
	return &resp, nil
}

func (slurmStruct SlurmStruct) DeleteCluster(ctx context.Context, req *pbslurm.DeleteClusterReq) (*pbslurm.DeleteClusterResp, error) {

	cmd := "usr/local/bin/sacctmgr delete cluster"
	cmd = cmd + req.Names
	cmd = cmd + "-i"

	result := ssh.ExecCommand(cmd)
	//var go_cluster_buffer ClusterInfoMsg
	resp := pbslurm.DeleteClusterResp{}
	resp.Result = result
	return &resp, nil

}

func (slurmStruct SlurmStruct) AddCluster(ctx context.Context, req *pbslurm.AddClusterReq) (*pbslurm.AddClusterResp, error) {

	cmd := "/usr/local/bin/sacctmgr add cluster "

	cmd = cmd + req.Name
	if len(req.Nodes) != 0 {
		cmd = cmd + " Nodes=" + req.Nodes
	}
	if len(req.Classification) != 0 {
		cmd = cmd + " Classification=" + req.Classification
	}
	if len(req.ControlHost) != 0 {
		cmd = cmd + " ControlHost=\"" + req.ControlHost + "\""
	}
	if len(req.ControlPort) != 0 {
		cmd = cmd + " ControlPort=" + req.ControlPort
	}
	if len(req.CpuCount) != 0 {
		cmd = cmd + " CpuCount=" + req.CpuCount
	}
	if len(req.Dimensions) != 0 {
		cmd = cmd + " Dimensions=" + req.Dimensions
	}
	if len(req.DimSize) != 0 {
		cmd = cmd + " DimSize=" + req.DimSize
	}
	if len(req.Flags) != 0 {
		cmd = cmd + " Flags=" + req.Flags
	}
	if len(req.PluginIdSelect) != 0 {
		cmd = cmd + " GrpNodes=" + req.PluginIdSelect
	}
	if len(req.RpcVersion) != 0 {
		cmd = cmd + " RpcVersion=" + req.RpcVersion
	}

	cmd = cmd + " -i"

	result := ssh.ExecCommand(cmd)

	resp := pbslurm.AddClusterResp{}
	resp.Result = result

	return &resp, nil
}

func (slurmStruct SlurmStruct) GetCluster(ctx context.Context, req *pbslurm.GetClusterReq) (*pbslurm.GetClusterResp, error) {

	clusterList := tianhe.GetClusterInfo()

	resp := pbslurm.GetClusterResp{}
	for _, cluster := range clusterList.ClusterInfoList {
		clusterInfoResult := cluster
		if strings.Contains(cluster.Name, req.ClusterName) {
			resp.ClusterInfos = append(resp.ClusterInfos, &clusterInfoResult)
		}
	}

	return &resp, nil
}
