package slurmer

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"context"
)

func (slurmStruct SlurmStruct) ListJobs(ctx context.Context, req *pbslurm.ListJobsReq) (*pbslurm.ListJobsResp, error) {

	resp := tianhe.GetAllJobs()

	return &resp, nil
}

func (slurmStruct SlurmStruct) GetJob(ctx context.Context, req *pbslurm.GetJobReq) (*pbslurm.GetJobResp, error) {
	jobList := tianhe.GetJob(req.JobId)
	var resp = pbslurm.GetJobResp{}
	resp.JobInfo = &jobList

	return &resp, nil
}

func (slurmStruct SlurmStruct) DeleteJob(ctx context.Context, req *pbslurm.DeleteJobReq) (*pbslurm.DeleteJobResp, error) {
	errorCode := tianhe.DeleteJob(req.JobId)
	var resp = pbslurm.DeleteJobResp{}
	resp.ErrorCode = errorCode
	return &resp, nil
}
