package slurmer

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"context"
)

func (slurmStruct SlurmStruct) SubmitJob(ctx context.Context, req *pbslurm.SubmitJobReq) (*pbslurm.SubmitJobResp, error) {
	submitJobResp := tianhe.SubmitJob(req)
	var resp = pbslurm.SubmitJobResp{}
	submitResponseMsg := pbslurm.SubmitResponseMsg{}
	submitResponseMsg.JobId = submitJobResp.SubmitResponseMsg[0].JobId
	submitResponseMsg.StepId = submitJobResp.SubmitResponseMsg[0].StepId
	submitResponseMsg.ErrorCode = submitJobResp.SubmitResponseMsg[0].ErrorCode

	resp.SubmitResponseMsg = append(resp.SubmitResponseMsg, &submitResponseMsg)

	return &resp, nil
}

func (slurmStruct SlurmStruct) UpdateJob(ctx context.Context, req *pbslurm.UpdateJobReq) (*pbslurm.UpdateJobResp, error) {
	errorCode := tianhe.UpdateJob(req.Data, req.JobId)
	var resp = pbslurm.UpdateJobResp{}
	resp.ErrorCode = errorCode
	return &resp, nil
}
