package slurmer

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service/tianhe"
	"code.gitlink.org.cn/JCCE/PCM.git/common/ssh"
	"context"
)

func (slurmStruct SlurmStruct) ListQoses(ctx context.Context, req *pbslurm.ListQosesReq) (*pbslurm.ListQosesResp, error) {
	qosList := tianhe.ListQoses()
	var resp = pbslurm.ListQosesResp{}
	resp.QosInfos = qosList
	return &resp, nil
}

func (slurmStruct SlurmStruct) DeleteQos(ctx context.Context, req *pbslurm.DeleteQosReq) (*pbslurm.DeleteQosResp, error) {

	cmd := "/usr/local/bin/sacctmgr delete qos "
	cmd = cmd + req.Names
	cmd = cmd + " -i"

	result := ssh.ExecCommand(cmd)

	resp := pbslurm.DeleteQosResp{}
	resp.Result = result

	return &resp, nil
}

func (slurmStruct SlurmStruct) GetQos(ctx context.Context, req *pbslurm.GetQosReq) (*pbslurm.GetQosResp, error) {
	qosInfo := tianhe.GetQos(req.Name)
	var resp = pbslurm.GetQosResp{}
	resp.QosInfo = &qosInfo

	return &resp, nil
}

func (slurmStruct SlurmStruct) AddQos(ctx context.Context, req *pbslurm.AddQosReq) (*pbslurm.AddQosResp, error) {
	cmd := "/usr/local/bin/sacctmgr add qos "
	cmd = cmd + req.QosInfo.Name

	if len(req.QosInfo.Description) != 0 {
		cmd = cmd + " Description=" + req.QosInfo.Description
	}

	if len(req.QosInfo.Name) != 0 {
		cmd = cmd + " Name=" + req.QosInfo.Name
	}

	cmd = cmd + " -i"

	result := ssh.ExecCommand(cmd)
	resp := pbslurm.AddQosResp{}

	resp.Result = result
	return &resp, nil
}
