package tianhe

/*
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include<slurm/slurm.h>
#include<slurm/slurm_errno.h>
#include <signal.h>

 struct job_info_msg *get_job_info(){

      struct job_info_msg* job_buffer;
      if(slurm_load_jobs ((time_t) NULL,
		&job_buffer, SHOW_ALL)) {
			return NULL;
		}

	return job_buffer;
 }

struct job_info* job_from_list(struct job_info_msg *list, int i){
	 return &list->job_array[i];
}

  struct job_info_msg *get_single_job_info(uint32_t id){
   	struct job_info_msg* job_buffer;
	if( slurm_load_job (&job_buffer, id, SHOW_DETAIL)) {
		return NULL;
	}
	return job_buffer;
 }

int delete_job(uint32_t id) {
	int error_code = 0;
    error_code = slurm_kill_job (id, SIGKILL, 0);
    if (error_code) {
			char msg[64];
			sprintf(msg, "slurm_kill_job(%.12s)",id);
			slurm_perror (msg);
			return error_code;
	}
	return (error_code);
}

	//static time_t last_update_time = (time_t) NULL;
	//int error_code;
	//job_info_msg_t * job_info_msg_ptr = NULL;
	//
	//error_code = slurm_load_jobs (last_update_time, &job_info_msg_ptr, 1);
	//if (error_code) {
	//	slurm_perror ("slurm_load_jobs");
	//	return (error_code);
	//}
	//
	//slurm_print_job_info_msg ( stdout, job_info_msg_ptr, 1 ) ;
	//
	//slurm_free_job_info_msg ( job_info_msg_ptr ) ;

*/
import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
)

func GetAllJobs() pbslurm.ListJobsResp {
	var jobResp pbslurm.ListJobsResp
	cJobBuffer := C.get_job_info()
	if cJobBuffer == nil {
		jobResp.RecordCount = uint32(0)
		jobResp.JobInfos = nil
		return jobResp
	}

	jobResp.RecordCount = uint32(cJobBuffer.record_count)
	for i := uint32(0); i < jobResp.RecordCount; i++ {
		job := C.job_from_list(cJobBuffer, C.int(i))
		goJob := JobInfoConvertCToGo(job)
		jobResp.JobInfos = append(jobResp.JobInfos, &goJob)
	}
	jobResp.Code = 200
	jobResp.Msg = "success"
	C.slurm_free_job_info_msg(cJobBuffer)

	return jobResp
}

func DeleteJob(id uint32) int32 {
	errorCode := C.slurm_kill_job(C.uint32_t(id), C.SIGKILL, C.uint16_t(0))
	return int32(errorCode)
}

func GetJob(id uint32) pbslurm.JobInfoGet {
	var goJobBuffer pbslurm.JobInfoGet
	cJobBuffer := C.get_single_job_info(C.uint32_t(id))
	if cJobBuffer == nil {
		return goJobBuffer
	}
	job := C.job_from_list(cJobBuffer, C.int(0))
	goJob := JobInfoConvertCToGo(job)
	goJobBuffer = goJob

	C.slurm_free_job_info_msg(cJobBuffer)

	return goJobBuffer
}
