package tianhe

/*
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include<slurm/slurm.h>
#include<slurm/slurm_errno.h>

struct submit_response_msg *submit_job(struct job_descriptor *desc)
{

	struct submit_response_msg *resp_msg;
	if (slurm_submit_batch_job(desc,
				&resp_msg)) {
		return NULL;
	}
	return resp_msg;

}

void free_submit_response_msg(struct submit_response_msg *msg)
{
	 slurm_free_submit_response_response_msg(msg);
}

int update_job (struct job_descriptor *msg) {

	 return slurm_update_job (msg);
}
*/
import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	"fmt"
	"unsafe"
)

func SubmitJob(goStruct *pbslurm.SubmitJobReq) pbslurm.SubmitJobResp {

	var cStruct C.struct_job_descriptor

	C.slurm_init_job_desc_msg(&cStruct)
	if goStruct.Data.Account != "" {
		accountS := C.CString(goStruct.Data.Account)
		defer C.free(unsafe.Pointer(accountS))
		cStruct.account = accountS
	}
	if goStruct.Data.AcctgFreq != "" {
		acctgFreqS := C.CString(goStruct.Data.AcctgFreq)
		defer C.free(unsafe.Pointer(acctgFreqS))
		cStruct.acctg_freq = acctgFreqS
	}
	if goStruct.Data.AllocNode != "" {
		allocNodeS := C.CString(goStruct.Data.AllocNode)
		defer C.free(unsafe.Pointer(allocNodeS))
		cStruct.alloc_node = allocNodeS
	}
	if goStruct.Data.AllocRespPort != 0 {
		cStruct.alloc_resp_port = C.uint16_t(goStruct.Data.AllocRespPort)
	}
	if goStruct.Data.AllocSid != 0 {
		cStruct.alloc_sid = C.uint32_t(goStruct.Data.AllocSid)
	}
	if len(goStruct.Data.Argv) > 0 {
		cStruct.argc = C.uint32_t(len(goStruct.Data.Argv))
		cArray := C.malloc(C.size_t(C.size_t(len(goStruct.Data.Argv)) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		for i := 0; i < len(goStruct.Data.Argv); i++ {
			a[i] = C.CString(goStruct.Data.Argv[i].String())
		}
		cStruct.argv = (**C.char)(cArray)
		fmt.Printf("test\n")
	}

	if goStruct.Data.ArrayInx != "" {
		arrayInxS := C.CString(goStruct.Data.ArrayInx)
		defer C.free(unsafe.Pointer(arrayInxS))
		cStruct.array_inx = arrayInxS
	}
	if goStruct.Data.BeginTime != 0 {
		cStruct.begin_time = C.int64_t(goStruct.Data.BeginTime)
	}
	if goStruct.Data.CkptInterval != 0 {
		cStruct.ckpt_interval = C.uint16_t(goStruct.Data.CkptInterval)
	}
	if goStruct.Data.CkptDir != "" {
		ckptDirS := C.CString(goStruct.Data.CkptDir)
		defer C.free(unsafe.Pointer(ckptDirS))
		cStruct.ckpt_dir = ckptDirS
	}
	if goStruct.Data.Comment != "" {
		commentS := C.CString(goStruct.Data.Comment)
		defer C.free(unsafe.Pointer(commentS))
		cStruct.comment = commentS
	}
	if goStruct.Data.Contiguous != 0 {
		cStruct.contiguous = C.uint16_t(goStruct.Data.Contiguous)
	}
	if goStruct.Data.CpuBind != "" {
		cpuBindS := C.CString(goStruct.Data.CpuBind)
		defer C.free(unsafe.Pointer(cpuBindS))
		cStruct.cpu_bind = cpuBindS
	}
	if goStruct.Data.CpuBindType != 0 {
		cStruct.cpu_bind_type = C.uint16_t(goStruct.Data.CpuBindType)
	}
	if goStruct.Data.Dependency != "" {
		dependencyS := C.CString(goStruct.Data.Dependency)
		defer C.free(unsafe.Pointer(dependencyS))
		cStruct.dependency = dependencyS
	}
	if goStruct.Data.EndTime != 0 {
		cStruct.end_time = C.int64_t(goStruct.Data.EndTime)
	}
	if len(goStruct.Data.Environment) > 0 {
		cStruct.env_size = C.uint32_t(len(goStruct.Data.Environment))
		cArray := C.malloc(C.size_t(C.size_t(len(goStruct.Data.Environment)) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		for i := 0; i < len(goStruct.Data.Environment); i++ {
			a[i] = C.CString(goStruct.Data.Environment[i].String())
			defer C.free(unsafe.Pointer(a[i]))
		}
		cStruct.environment = (**C.char)(cArray)
	} else {
		cStruct.env_size = 1
		cArray := C.malloc(C.size_t(C.size_t(1) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		a[0] = C.CString("SLURM_GO_JOB=TRUE")
		defer C.free(unsafe.Pointer(a[0]))
		cStruct.environment = (**C.char)(cArray)

	}
	if goStruct.Data.ExcNodes != "" {
		excNodesS := C.CString(goStruct.Data.ExcNodes)
		defer C.free(unsafe.Pointer(excNodesS))
		cStruct.exc_nodes = excNodesS
	}
	if goStruct.Data.Features != "" {
		featuresS := C.CString(goStruct.Data.Features)
		defer C.free(unsafe.Pointer(featuresS))
		cStruct.features = featuresS
	}
	if goStruct.Data.GroupId != 0 {
		cStruct.group_id = C.uint32_t(goStruct.Data.GroupId)
	}
	if goStruct.Data.Immediate != 0 {
		cStruct.immediate = C.uint16_t(goStruct.Data.Immediate)
	}
	if goStruct.Data.JobId != 0 {
		cStruct.job_id = C.uint32_t(goStruct.Data.JobId)
	}
	if goStruct.Data.KillOnNodeFail != 0 {
		cStruct.kill_on_node_fail = C.uint16_t(goStruct.Data.KillOnNodeFail)
	}
	if goStruct.Data.Licenses != "" {
		licensesS := C.CString(goStruct.Data.Licenses)
		defer C.free(unsafe.Pointer(licensesS))
		cStruct.licenses = licensesS
	}
	if goStruct.Data.MailType != 0 {
		cStruct.mail_type = C.uint16_t(goStruct.Data.MailType)
	}
	if goStruct.Data.MailUser != "" {
		mailUserS := C.CString(goStruct.Data.MailUser)
		defer C.free(unsafe.Pointer(mailUserS))
		cStruct.mail_user = mailUserS
	}
	if goStruct.Data.MemBind != "" {
		memBindS := C.CString(goStruct.Data.MemBind)
		defer C.free(unsafe.Pointer(memBindS))
		cStruct.mem_bind = memBindS
	}
	if goStruct.Data.MemBindType != 0 {
		cStruct.mem_bind_type = C.uint16_t(goStruct.Data.MemBindType)
	}
	if goStruct.Data.Name != "" {
		nameS := C.CString(goStruct.Data.Name)
		defer C.free(unsafe.Pointer(nameS))
		cStruct.name = nameS
	}
	if goStruct.Data.Network != "" {
		networkS := C.CString(goStruct.Data.Network)
		defer C.free(unsafe.Pointer(networkS))
		cStruct.network = networkS
	}
	if goStruct.Data.Nice != 0 {
		cStruct.nice = C.uint16_t(goStruct.Data.Nice)
	}
	if goStruct.Data.NumTasks != 0 {
		cStruct.num_tasks = C.uint32_t(goStruct.Data.NumTasks)
	}
	if goStruct.Data.OpenMode != 0 {
		cStruct.open_mode = C.uint8_t(goStruct.Data.OpenMode)
	}
	if goStruct.Data.OtherPort != 0 {
		cStruct.other_port = C.uint16_t(goStruct.Data.OtherPort)
	}
	if goStruct.Data.Overcommit != 0 {
		cStruct.overcommit = C.uint8_t(goStruct.Data.Overcommit)
	}
	if goStruct.Data.Partition != "" {
		partitionS := C.CString(goStruct.Data.Partition)
		defer C.free(unsafe.Pointer(partitionS))
		cStruct.partition = partitionS
	}
	if goStruct.Data.PlaneSize != 0 {
		cStruct.plane_size = C.uint16_t(goStruct.Data.PlaneSize)
	}
	if goStruct.Data.Priority != 0 {
		cStruct.priority = C.uint32_t(goStruct.Data.Priority)
	}
	if goStruct.Data.Profile != 0 {
		cStruct.profile = C.uint32_t(goStruct.Data.Profile)
	}
	if goStruct.Data.Qos != "" {
		qosS := C.CString(goStruct.Data.Qos)
		defer C.free(unsafe.Pointer(qosS))
		cStruct.qos = qosS
	}
	if goStruct.Data.Reboot != 0 {
		cStruct.reboot = C.uint16_t(goStruct.Data.Reboot)
	}
	if goStruct.Data.RespHost != "" {
		respHostS := C.CString(goStruct.Data.RespHost)
		defer C.free(unsafe.Pointer(respHostS))
		cStruct.resp_host = respHostS
	}
	if goStruct.Data.ReqNodes != "" {
		reqNodesS := C.CString(goStruct.Data.ReqNodes)
		defer C.free(unsafe.Pointer(reqNodesS))
		cStruct.req_nodes = reqNodesS
	}
	if goStruct.Data.Requeue != 0 {
		cStruct.requeue = C.uint16_t(goStruct.Data.Requeue)
	}
	if goStruct.Data.Reservation != "" {
		reservationS := C.CString(goStruct.Data.Reservation)
		defer C.free(unsafe.Pointer(reservationS))
		cStruct.reservation = reservationS
	}
	if goStruct.Data.Script != "" {
		scriptS := C.CString(goStruct.Data.Script)
		defer C.free(unsafe.Pointer(scriptS))
		cStruct.script = scriptS
	}
	if goStruct.Data.Shared != 0 {
		cStruct.shared = C.uint16_t(goStruct.Data.Shared)
	}
	if goStruct.Data.SpankJobEnvSize != 0 {
		cStruct.spank_job_env_size = C.uint32_t(goStruct.Data.SpankJobEnvSize)
	}
	if goStruct.Data.TaskDist != 0 {
		cStruct.task_dist = C.uint16_t(goStruct.Data.TaskDist)
	}
	if goStruct.Data.TimeLimit != 0 {
		cStruct.time_limit = C.uint32_t(goStruct.Data.TimeLimit)
	}
	if goStruct.Data.TimeMin != 0 {
		cStruct.time_min = C.uint32_t(goStruct.Data.TimeMin)
	}
	//if go_struct.User_id != 0 {
	//	c_struct.user_id = C.uint32_t(go_struct.User_id)
	//}
	cStruct.user_id = C.uint32_t(goStruct.Data.UserId)

	if goStruct.Data.WaitAllNodes != 0 {
		cStruct.wait_all_nodes = C.uint16_t(goStruct.Data.WaitAllNodes)
	}
	if goStruct.Data.WarnSignal != 0 {
		cStruct.warn_signal = C.uint16_t(goStruct.Data.WarnSignal)
	}
	if goStruct.Data.WarnTime != 0 {
		cStruct.warn_time = C.uint16_t(goStruct.Data.WarnTime)
	}
	if goStruct.Data.WorkDir != "" {
		workDirS := C.CString(goStruct.Data.WorkDir)
		defer C.free(unsafe.Pointer(workDirS))
		cStruct.work_dir = workDirS
	}
	if goStruct.Data.CpusPerTask != 0 {
		cStruct.cpus_per_task = C.uint16_t(goStruct.Data.CpusPerTask)
	}
	if goStruct.Data.MinCpus != 0 {
		cStruct.min_cpus = C.uint32_t(goStruct.Data.MinCpus)
	}
	if goStruct.Data.MaxCpus != 0 {
		cStruct.max_cpus = C.uint32_t(goStruct.Data.MaxCpus)
	}
	if goStruct.Data.MinNodes != 0 {
		cStruct.min_nodes = C.uint32_t(goStruct.Data.MinNodes)
	}
	if goStruct.Data.MaxNodes != 0 {
		cStruct.max_nodes = C.uint32_t(goStruct.Data.MaxNodes)
	}
	if goStruct.Data.BoardsPerNode != 0 {
		cStruct.boards_per_node = C.uint16_t(goStruct.Data.BoardsPerNode)
	}
	if goStruct.Data.SocketsPerBoard != 0 {
		cStruct.sockets_per_board = C.uint16_t(goStruct.Data.SocketsPerBoard)
	}
	if goStruct.Data.SocketsPerNode != 0 {
		cStruct.sockets_per_node = C.uint16_t(goStruct.Data.SocketsPerNode)
	}
	if goStruct.Data.CoresPerSocket != 0 {
		cStruct.cores_per_socket = C.uint16_t(goStruct.Data.CoresPerSocket)
	}
	if goStruct.Data.ThreadsPerCore != 0 {
		cStruct.threads_per_core = C.uint16_t(goStruct.Data.ThreadsPerCore)
	}
	if goStruct.Data.NtasksPerNode != 0 {
		cStruct.ntasks_per_node = C.uint16_t(goStruct.Data.NtasksPerNode)
	}
	if goStruct.Data.NtasksPerSocket != 0 {
		cStruct.ntasks_per_socket = C.uint16_t(goStruct.Data.NtasksPerSocket)
	}
	if goStruct.Data.NtasksPerCore != 0 {
		cStruct.ntasks_per_core = C.uint16_t(goStruct.Data.NtasksPerCore)
	}
	if goStruct.Data.NtasksPerBoard != 0 {
		cStruct.ntasks_per_board = C.uint16_t(goStruct.Data.NtasksPerBoard)
	}
	if goStruct.Data.PnMinCpus != 0 {
		cStruct.pn_min_cpus = C.uint16_t(goStruct.Data.PnMinCpus)
	}
	if goStruct.Data.PnMinMemory != 0 {
		cStruct.pn_min_memory = C.uint32_t(goStruct.Data.PnMinMemory)
	}
	if goStruct.Data.PnMinTmpDisk != 0 {
		cStruct.pn_min_tmp_disk = C.uint32_t(goStruct.Data.PnMinTmpDisk)
	}
	if goStruct.Data.ReqSwitch != 0 {
		cStruct.req_switch = C.uint32_t(goStruct.Data.ReqSwitch)
	}
	if goStruct.Data.StdErr != "" {
		stdErrS := C.CString(goStruct.Data.StdErr)
		defer C.free(unsafe.Pointer(stdErrS))
		cStruct.std_err = stdErrS
	}
	if goStruct.Data.StdIn != "" {
		stdInS := C.CString(goStruct.Data.StdIn)
		defer C.free(unsafe.Pointer(stdInS))
		cStruct.std_in = stdInS
	}
	if goStruct.Data.StdOut != "" {
		stdOutS := C.CString(goStruct.Data.StdOut)
		defer C.free(unsafe.Pointer(stdOutS))
		cStruct.std_out = stdOutS
	}

	if goStruct.Data.Wait4Switch != 0 {
		cStruct.wait4switch = C.uint32_t(goStruct.Data.Wait4Switch)
	}
	if goStruct.Data.Wckey != "" {
		wckeyS := C.CString(goStruct.Data.Wckey)
		defer C.free(unsafe.Pointer(wckeyS))
		cStruct.wckey = wckeyS
	}

	cMsg := C.submit_job(&cStruct)

	defer C.free_submit_response_msg(cMsg)
	if cMsg == nil {
		goMsg := pbslurm.SubmitJobResp{}
		goMsg.SubmitResponseMsg[0].JobId = 1<<31 - 1
		goMsg.SubmitResponseMsg[0].ErrorCode = uint32(C.slurm_get_errno())
		return goMsg
	}
	goMsg := submitResponseMsgConvertCToGo(cMsg)

	return goMsg

}

func UpdateJob(updateInfo *pbslurm.UpdateJobOptions, JobId uint32) int32 {

	var cStruct C.struct_job_descriptor
	C.slurm_init_job_desc_msg(&cStruct)
	if updateInfo.Partition != "" {
		partitionS := C.CString(updateInfo.Partition)
		defer C.free(unsafe.Pointer(partitionS))
		cStruct.partition = partitionS
	}
	if updateInfo.Qos != "" {
		qosS := C.CString(updateInfo.Qos)
		defer C.free(unsafe.Pointer(qosS))
		cStruct.qos = qosS
	}
	if updateInfo.NumTasks != 0 {
		cStruct.num_tasks = C.uint32_t(updateInfo.NumTasks)
	}
	if updateInfo.NtasksPerCore != 0 {
		cStruct.ntasks_per_core = C.uint16_t(updateInfo.NtasksPerCore)
	}

	if updateInfo.NtasksPerNode != 0 {
		cStruct.ntasks_per_node = C.uint16_t(updateInfo.NtasksPerNode)
	}
	if updateInfo.NtasksPerSocket != 0 {
		cStruct.ntasks_per_socket = C.uint16_t(updateInfo.NtasksPerSocket)
	}

	if updateInfo.MaxNodes != 0 {
		cStruct.max_nodes = C.uint32_t(updateInfo.MaxNodes)
	}
	if updateInfo.MinNodes != 0 {
		cStruct.min_nodes = C.uint32_t(updateInfo.MinNodes)
	}

	jobInfo := GetJob(JobId)

	if jobInfo.JobState != C.JOB_PENDING {
		return int32(C.ESLURM_JOB_NOT_PENDING)
	}
	cStruct.job_id = C.uint32_t(JobId)

	err := C.update_job(&cStruct)

	return int32(err)

}

func submitResponseMsgConvertCToGo(cStruct *C.struct_submit_response_msg) pbslurm.SubmitJobResp {
	var goStruct pbslurm.SubmitJobResp

	goStruct.SubmitResponseMsg[0].JobId = uint32(cStruct.job_id)
	goStruct.SubmitResponseMsg[0].StepId = uint32(cStruct.step_id)
	goStruct.SubmitResponseMsg[0].ErrorCode = uint32(cStruct.error_code)
	return goStruct
}
