package tianhe

/*
//#cgo LDFLAGS: -lslurm
#include<stdlib.h>
#include<slurm/slurm.h>
#include<slurm/slurm_errno.h>
 struct reserve_info_msg *get_reserve_info(){
   	struct reserve_info_msg* reservation_buffer;
       if(slurm_load_reservations ((time_t) NULL,
		&reservation_buffer))
		return NULL;
	return reservation_buffer;
 }
 struct reserve_info* reservation_from_list(struct reserve_info_msg *list, int i){
    return &list->reservation_array[i];
}
 void free_reservation_buffer(void* buffer){
	slurm_free_reservation_info_msg ((struct reserve_info_msg*)buffer);
  }
*/
import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
)

type ReservationInfoMsg struct {
	LastUpdate      int64
	RecordCount     uint32
	ReservationList []pbslurm.ReservationInfo
	ErrorCode       uint32
}

func ReservationInfoConvertCToGo(cStruct *C.struct_reserve_info) pbslurm.ReservationInfo {
	var goStruct pbslurm.ReservationInfo

	goStruct.Accounts = C.GoString(cStruct.accounts)
	goStruct.EndTime = int64(cStruct.end_time)
	goStruct.Features = C.GoString(cStruct.features)
	goStruct.Flags = uint32(cStruct.flags)
	goStruct.Licenses = C.GoString(cStruct.licenses)
	goStruct.Name = C.GoString(cStruct.name)
	goStruct.Features = C.GoString(cStruct.features)
	goStruct.NodeCnt = uint32(cStruct.node_cnt)
	goStruct.CoreCnt = uint32(cStruct.core_cnt)
	/*t := C.find_node_inx(c_struct.node_inx)

	fmt.Printf("%d", t)
	go_struct.Node_inx = make([]int32, t, t)
	for i := int32(0); i < int32(t); i++ {
		go_struct.Node_inx[i] = int32(C.int32_ptr(c_struct.node_inx, C.int(i)))

	}*/
	goStruct.NodeList = C.GoString(cStruct.node_list)
	goStruct.Partition = C.GoString(cStruct.partition)
	goStruct.StartTime = int64(cStruct.start_time)
	//go_struct.clusters = C.GoString(c_struct.clusters)
	return goStruct
}

func GetAllReservation() ReservationInfoMsg {
	var goReservationBuffer ReservationInfoMsg
	cReservationBuffer := C.get_reserve_info()
	if cReservationBuffer == nil {
		goReservationBuffer.LastUpdate = int64(0)
		goReservationBuffer.RecordCount = uint32(0)
		goReservationBuffer.ErrorCode = uint32(C.slurm_get_errno())
		return goReservationBuffer
	}
	goReservationBuffer.LastUpdate = int64(cReservationBuffer.last_update)
	goReservationBuffer.RecordCount = uint32(cReservationBuffer.record_count)
	goReservationBuffer.ReservationList = make([]pbslurm.ReservationInfo, cReservationBuffer.record_count, cReservationBuffer.record_count)
	for i := uint32(0); i < goReservationBuffer.RecordCount; i++ {
		reservation := C.reservation_from_list(cReservationBuffer, C.int(i))
		goReservation := ReservationInfoConvertCToGo(reservation)
		goReservationBuffer.ReservationList[i] = goReservation
	}
	C.slurm_free_reservation_info_msg(cReservationBuffer)

	return goReservationBuffer
}

func GetReservationsInfo() ReservationInfoMsg {
	var goReservationBuffer ReservationInfoMsg
	cReservationBuffer := C.get_reserve_info()
	goReservationBuffer.RecordCount = uint32(cReservationBuffer.record_count)
	goReservationBuffer.ReservationList = make([]pbslurm.ReservationInfo, cReservationBuffer.record_count, cReservationBuffer.record_count)

	for i := uint32(0); i < goReservationBuffer.RecordCount; i++ {
		Reservation := C.reservation_from_list(cReservationBuffer, C.int(i))
		goReservation := ReservationDescriptorConvertCToGo(Reservation)
		goReservationBuffer.ReservationList[i] = goReservation
	}
	return goReservationBuffer
}

func ReservationDescriptorConvertCToGo(cStruct *C.struct_reserve_info) pbslurm.ReservationInfo {
	var goStruct pbslurm.ReservationInfo
	goStruct.Name = C.GoString(cStruct.name)
	return goStruct
}
