package server

import (
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_vm/gen/idl"
	"context"
	"github.com/golang/glog"
	"google.golang.org/grpc/codes"
	"google.golang.org/grpc/status"
)

type Server struct {
	ecspb.UnimplementedEcsServiceServer
}

// CreateMultipleEcs return create cloudy ecs
func (s *Server) CreateMultipleEcs(ctx context.Context, reqs *ecspb.CreateEcsMultipleReq) (*ecspb.CreateEcsMultipleResp, error) {
	resp, err := CreateMultipleEcs(ctx, reqs)
	if err != nil {
		glog.Errorf("ListEcsDetail error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// CreateEcs return create ecs
func (s *Server) CreateEcs(ctx context.Context, req *ecspb.CreateEcsReq) (*ecspb.CreateEcsResp, error) {
	resp, err := CreateEcs(ctx, req)
	if err != nil {
		glog.Errorf("ListEcsDetail error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// DeleteEcs return Delete ecs
func (s *Server) DeleteEcs(ctx context.Context, req *ecspb.DeleteEcsReq) (*ecspb.DeleteEcsResp, error) {
	resp, err := DeleteEcs(ctx, req)
	if err != nil {
		glog.Errorf("ListEcsDetail error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// UpdateEcs return Update ecs
func (s *Server) UpdateEcs(ctx context.Context, req *ecspb.UpdateEcsReq) (*ecspb.UpdateEcsResp, error) {
	resp, err := UpdateEcs(ctx, req)
	if err != nil {
		glog.Errorf("ListEcsDetail error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// ListEcsDetail return ecs detail
func (s *Server) ListEcsDetail(ctx context.Context, req *ecspb.ListDetailReq) (*ecspb.ListDetailResp, error) {
	resp, err := ListDetail(ctx, req)
	if err != nil {
		glog.Errorf("ListEcsDetail error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// ListEcs return ecs list
func (s *Server) ListEcs(ctx context.Context, req *ecspb.ListReq) (*ecspb.ListResp, error) {
	resp, err := List(ctx, req)
	if err != nil {
		glog.Errorf("ListEcs error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// ListEcsAll return all ecs
func (s *Server) ListEcsAll(ctx context.Context, req *ecspb.ListAllReq) (*ecspb.ListResp, error) {
	resp, err := ListAll(ctx)
	if err != nil {
		glog.Errorf("ListEcsAll error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// ActionEcs return ecs action
func (s *Server) ActionEcs(ctx context.Context, req *ecspb.ActionReq) (*ecspb.ActionResp, error) {
	resp, err := ActionEcs(ctx, req)
	if err != nil {
		glog.Errorf("ActionEcs error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}

// ListEcsImages return ecs image list
func (s *Server) ListEcsImages(ctx context.Context, req *ecspb.ListImagesReq) (*ecspb.ListImagesResp, error) {
	resp, err := ListImages(ctx, req)
	if err != nil {
		glog.Errorf("ListImages error %+v", err)
		return nil, status.Errorf(codes.Internal, err.Error())
	}
	return resp, nil
}
