package server

import (
	pbecs "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_vm/gen/idl"
	"code.gitlink.org.cn/JCCE/PCM.git/common/tenanter"
	pbtenant "code.gitlink.org.cn/JCCE/PCM.git/tenant/gen/idl"
	"os"
	"testing"
)

var (
	aliTenant, tcTenant, hwTenant, k8sTenant []tenanter.Tenanter
)

func TestMain(m *testing.M) {
	err := tenanter.LoadCloudConfigs("../../../tenanter.yaml")
	if err != nil {
		panic(err)
	}
	if aliTenant, err = tenanter.GetTenanters(pbtenant.CloudProvider(pbecs.CloudProvider_ali)); err != nil {
		panic("get aliTenant failed")
	}
	if tcTenant, err = tenanter.GetTenanters(pbtenant.CloudProvider(pbecs.CloudProvider_tencent)); err != nil {
		panic("get tcTenant failed")
	}
	if hwTenant, err = tenanter.GetTenanters(pbtenant.CloudProvider(pbecs.CloudProvider_huawei)); err != nil {
		panic("get hwTenant failed")
	}
	if k8sTenant, err = tenanter.GetTenanters(pbtenant.CloudProvider(pbecs.CloudProvider_k8s)); err != nil {
		panic("get awsTenant failed")
	}
	os.Exit(m.Run())
}
