package model

type ServerConfig struct {
	Name        string        `mapstructure:"name"`
	GormInfo    GormConfig    `mapstructure:"gorm"`
	RedisInfo   RedisConfig   `mapstructure:"redis"`
	GatewayInfo GatewayConfig `mapstructure:"gateway"`
	SlurmInfo   SlurmConfig   `mapstructure:"slurm"`
	PodInfo     PodConfig     `mapstructure:"pod"`
	VmInfo      VmConfig      `mapstructure:"vm"`
	AliInfo     AliConfig     `mapstructure:"ali"`
	TencentInfo TencentConfig `mapstructure:"tencent"`
	HuaweiInfo  HuaweiConfig  `mapstructure:"huawei"`
	K8sInfo     K8sConfig     `mapstructure:"k8s"`
}

type GormConfig struct {
	Host     string `mapstructure:"host"`
	Port     int    `mapstructure:"port"`
	Name     string `mapstructure:"name"`
	Password string `mapstructure:"password"`
	DBName   string `mapstructure:"dbName"`
}

type RedisConfig struct {
	Host     string `mapstructure:"host"`
	Port     int    `mapstructure:"port"`
	Password string `mapstructure:"password"`
	DB       int    `mapstructure:"db"`
}

type GatewayConfig struct {
	Address string `mapstructure:"addr"`
}

type SlurmConfig struct {
	Address string `mapstructure:"addr"`
}

type PodConfig struct {
	Address string `mapstructure:"addr"`
}

type VmConfig struct {
	Address string `mapstructure:"addr"`
}

type WebSocketConfig struct {
	Address  string `mapstructure:"addr"`
	Username string `mapstructure:"name"`
}

type AliConfig struct {
	provider     string `mapstructure:"provider"`
	name         string `mapstructure:"name"`
	accessid     string `mapstructure:"accessid"`
	accesssecret string `mapstructure:"accesssecret"`
}

type TencentConfig struct {
	provider     string `mapstructure:"provider"`
	name         string `mapstructure:"name"`
	accessid     string `mapstructure:"accessid"`
	accesssecret string `mapstructure:"accesssecret"`
}

type HuaweiConfig struct {
	provider     string `mapstructure:"provider"`
	name         string `mapstructure:"name"`
	accessid     string `mapstructure:"accessid"`
	accesssecret string `mapstructure:"accesssecret"`
}

type K8sConfig struct {
	provider string `mapstructure:"provider"`
	name     string `mapstructure:"name"`
	url      string `mapstructure:"url"`
	token    string `mapstructure:"token"`
}

type HarvesterConfig struct {
	provider string `mapstructure:"provider"`
	name     string `mapstructure:"name"`
	url      string `mapstructure:"url"`
	token    string `mapstructure:"token"`
}
