package main

import (
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_pod/server/ali"
)

/*
****
regionId ali:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
image: tencent nginx:latest

	   ali registry-vpc.cn-hangzhou.aliyuncs.com/eci_open/nginx
	huawei library/nginx:stable-alpine-perl

****
*/
func aliCreatePCM() (_err error) {
	request := ali.CreateCreateContainerGroupRequest()

	/****************PCM params******************/
	request.ProviderId = 3
	request.RegionId = "cn-east-3"
	request.Namespace = "pcm"
	/****************PCM params******************/
	request.ContainerGroupName = "pcm0518"
	requestContainer := make([]ali.CreateContainerGroupContainer, 1)
	requestContainer[0].Image = "nginx/nginx:latest"
	requestContainer[0].Name = "pcm"
	requestContainer[0].Cpu = "1"
	requestContainer[0].Memory = "2"
	request.Container = &requestContainer

	resp, _err := ali.CreateContainerGroup(request)
	println(resp.ContainerGroupId)

	return _err
}

func aliDescribePCM() (_err error) {
	request := ali.CreateDescribeContainerGroupsRequest()

	/****************PCM params******************/
	request.ProviderId = 3
	//ali:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
	request.RegionId = "cn-east-3"
	request.Namespace = "pcm"
	/****************PCM params******************/

	resp, _err := ali.DescribeContainerGroups(request)
	println(resp.ContainerGroups[0].ContainerGroupName)

	return _err
}

func aliUpdatePCM() (_err error) {
	request := ali.CreateUpdateContainerGroupRequest()

	/****************PCM params******************/
	request.ProviderId = 3
	request.RegionId = "cn-east-3"
	request.Namespace = "pcm"
	request.PcmId = "pcm0517"
	/****************PCM params******************/
	request.PodName = "pcm0517"
	request.RestartPolicy = "Never"
	requestContainer := make([]ali.UpdateContainerGroupContainer, 1)
	requestContainer[0].Cpu = "2"
	requestContainer[0].Memory = "4"
	requestContainer[0].Image = "nginx:latest"
	requestContainer[0].Name = "pcm"
	request.Container = &requestContainer

	resp, _err := ali.UpdateContainerGroup(request)
	println(resp.RequestId)

	return _err
}

func aliDeletePCM() (_err error) {

	request := ali.CreateDeleteContainerGroupRequest()
	/****************PCM params******************/
	request.ProviderId = 3
	//ali:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
	request.RegionId = "cn-east-3"
	request.Namespace = "pcm"
	request.PcmId = "hw-sdk-hwk8s"
	/****************PCM params******************/

	resp, _err := ali.DeleteContainerGroup(request)
	if _err != nil {
		return _err
	}
	println(resp.RequestId)

	return _err
}

func main() {

	err := aliDeletePCM()
	if err != nil {
		panic(err)
	}
}
