package main

import (
	"code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_pod/server/tencent"
	"fmt"
	"strconv"
)

/*
****
regionId tencent:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
image: tencent nginx:latest

	   tencent registry-vpc.cn-hangzhou.tencentyuncs.com/eci_open/nginx
	huawei library/nginx:stable-alpine-perl

****
*/
func tencentCreatePCM() (_err error) {
	request := v20180525.NewCreateEKSContainerInstancesRequest()

	/****************PCM params******************/
	request.ProviderId = 1
	request.RegionId = "ap-guangzhou"
	request.Namespace = "pcm"
	/****************PCM params******************/
	_name := "pcm-test-tencnet"
	_podImage := "nginx/nginx:latest"
	_podName := "pcm-test-container"
	_cpu, _ := strconv.ParseFloat("1", 64)
	_memory, _ := strconv.ParseFloat("2", 64)
	request.EksCiName = &_name
	requestContainer := make([]*v20180525.Container, 0)
	requestContainer = append(requestContainer, &v20180525.Container{
		Name:   &_podName,
		Image:  &_podImage,
		Cpu:    &_cpu,
		Memory: &_memory,
		//Command:    []*string{},
		Args: []*string{},
		//Envs:       []*pcm_pod_tencent.Env{},
		//Ports:      []*pcm_pod_tencent.Port{},
		//VolumeMounts: []*pcm_pod_tencent.VolumeMount{
		//	&pcm_pod_tencent.VolumeMount{
		//		Name:      "pcm-test-tencnet-volume",
		//		MountPath: "/data",
		//	},
		//},
	})
	request.Containers = requestContainer

	resp, _err := v20180525.CreateEKSContainerInstances(request)
	if _err != nil {
		fmt.Println(_err)
		return _err
	}
	fmt.Println(*resp.Response.RequestId)
	return _err
}

func tencentDescribePCM() (_err error) {
	request := v20180525.NewDescribeEKSContainerInstancesRequest()

	/****************PCM params******************/
	request.ProviderId = 1
	//tencent:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
	//request.RegionId = "cn-east-3"
	request.Namespace = "pcm"
	/****************PCM params******************/

	resp, _err := v20180525.DescribeEKSContainerInstances(request)
	if _err != nil {
		fmt.Println(_err)
		return _err
	}
	fmt.Println(*resp.Response.EksCis[0].EksCiId)

	return _err
}

func tencentUpdatePCM() (_err error) {
	request := v20180525.NewUpdateEKSContainerInstanceRequest()
	_eksCiId := "eksci-4ti4856m"
	_Name := "pcm-test-tencnet-update"
	_RestartPolicy := "Never"
	/****************PCM params******************/
	request.ProviderId = 1
	request.RegionId = "ap-guangzhou"
	request.Namespace = "pcm"
	request.EksCiId = &_eksCiId
	/****************PCM params******************/
	request.Name = &_Name
	_cpu, _ := strconv.ParseFloat("2", 64)
	_memory, _ := strconv.ParseFloat("4", 64)
	_image := "nginx/nginx:latest"
	_name := "pcm-update-container"
	request.RestartPolicy = &_RestartPolicy
	requestContainer := make([]*v20180525.Container, 0)
	requestContainer = append(requestContainer, &v20180525.Container{
		Name:   &_name,
		Image:  &_image,
		Cpu:    &_cpu,
		Memory: &_memory,
		//Command:    []*string{},
		Args: []*string{},
		//Envs:       []*pcm_pod_tencent.Env{},
		//Ports:      []*pcm_pod_tencent.Port{},
		//VolumeMounts: []*pcm_pod_tencent.VolumeMount{
		//	&pcm_pod_tencent.VolumeMount{
		//		Name:      "pcm-test-tencnet-volume",
		//		MountPath: "/data",
		//	},
		//},
	})
	request.Containers = requestContainer
	resp, _err := v20180525.UpdateEKSContainerInstance(request)
	if _err != nil {
		fmt.Println(_err)
		return _err
	}
	fmt.Println(*resp.Response.RequestId)

	return _err
}

func tencentDeletePCM() (_err error) {
	_eksCiId := "eksci-4ti4856m"
	request := v20180525.NewDeleteEKSContainerInstancesRequest()
	/****************PCM params******************/
	request.ProviderId = 1
	//tencent:cn-hangzhou  tc:ap-guangzhou  hw:  cn-east-3
	request.RegionId = "ap-guangzhou"
	request.Namespace = "pcm"
	request.EksCiIds = []*string{&_eksCiId}
	/****************PCM params******************/

	resp, _err := v20180525.DeleteEKSContainerInstances(request)
	if _err != nil {
		fmt.Println(_err)
		return _err
	}
	fmt.Println(*resp.Response.RequestId)

	return _err
}

func main() {
	//err := tencentCreatePCM()
	//err := tencentDescribePCM()
	//err := tencentUpdatePCM()
	err := tencentDeletePCM()
	if err != nil {
		panic(err)
	}
}
